package com.iotechn.unimall.admin.api.wuye;


import com.iotechn.unimall.data.domain.wuye.WuyeAmountInfo;
import com.iotechn.unimall.core.annotation.HttpMethod;
import com.iotechn.unimall.core.annotation.HttpOpenApi;
import com.iotechn.unimall.core.annotation.HttpParam;
import com.iotechn.unimall.core.annotation.HttpParamType;
import com.iotechn.unimall.core.annotation.param.NotNull;
import com.iotechn.unimall.core.exception.ServiceException;
import com.iotechn.unimall.data.model.Page;

import java.util.Date;

/**
 * infoService接口
 *
 * @author jlb
 * @date 2022-10-12
 */
@HttpOpenApi(group = "admin.wuye.wuyeAmountInfo", description = "info")
public interface IWuyeAmountInfoService {
    @HttpMethod(description = "新增", permission = "admin:wuye:wuyeAmountInfo:add", permissionParentName = "宠物管理", permissionName = "info管理")
    public Boolean add(@NotNull @HttpParam(name = "wuyeAmountInfo", type = HttpParamType.COMMON, description = "info") WuyeAmountInfo wuyeAmountInfo,
                       @HttpParam(name = "adminId", type = HttpParamType.ADMIN_ID, description = "adminId") Long adminId) throws ServiceException;

    @HttpMethod(description = "列表", permission = "admin:wuye:wuyeAmountInfo:list", permissionParentName = "宠物管理", permissionName = "info管理")
    public Page<WuyeAmountInfo> list(
            @HttpParam(name = "buildingNo", type = HttpParamType.COMMON, description = "楼号") String buildingNo,
            @HttpParam(name = "unitNo", type = HttpParamType.COMMON, description = "单元号") String unitNo,
            @HttpParam(name = "floor", type = HttpParamType.COMMON, description = "楼层") String floor,
            @HttpParam(name = "sourceNumber", type = HttpParamType.COMMON, description = "房源号") String sourceNumber,
            @HttpParam(name = "householder", type = HttpParamType.COMMON, description = "户主") String householder,
            @HttpParam(name = "predictedArea", type = HttpParamType.COMMON, description = "预测面积") Double predictedArea,
            @HttpParam(name = "actualMoney", type = HttpParamType.COMMON, description = "实际面积") Double actualMoney,
            @HttpParam(name = "propertyFee", type = HttpParamType.COMMON, description = "一年物业费（1.6元/平）") Double propertyFee,
            @HttpParam(name = "elevatorFee", type = HttpParamType.COMMON, description = "一年电梯费（一层30元/月，每增加一层累加3元/月）") Double elevatorFee,
            @HttpParam(name = "parkingSpace", type = HttpParamType.COMMON, description = "一年车位管理费（单独150元/月,子母225元/月）") Double parkingSpace,
            @HttpParam(name = "cheweiNo", type = HttpParamType.COMMON, description = "车位号") String cheweiNo,
            @HttpParam(name = "garage", type = HttpParamType.COMMON, description = "一年车库管理费（单独150元/月,子母225元/月）") Double garage,
            @HttpParam(name = "garageNo", type = HttpParamType.COMMON, description = "车库号") String garageNo,
            @HttpParam(name = "warehouse", type = HttpParamType.COMMON, description = "一年仓库管理费（200元/年）") Double warehouse,
            @HttpParam(name = "warehouseNo", type = HttpParamType.COMMON, description = "仓库号") String warehouseNo,
            @HttpParam(name = "garbageClearing", type = HttpParamType.COMMON, description = "垃圾清运费（平层建筑面积3元/平，带地下及阁楼5元/平）") Double garbageClearing,
            @HttpParam(name = "paymentDate", type = HttpParamType.COMMON, description = "缴费日期") Date paymentDate,
            @HttpParam(name = "paymentMethod", type = HttpParamType.COMMON, description = "缴费方式") String paymentMethod,
            @HttpParam(name = "totalActualPayment", type = HttpParamType.COMMON, description = "实际缴费总合计") Double totalActualPayment,
            @HttpParam(name = "paymentRange", type = HttpParamType.COMMON, description = "缴费区间") String paymentRange,
            @HttpParam(name = "deleteFlag", type = HttpParamType.COMMON, description = "删除标识") Long deleteFlag,
            @HttpParam(name = "gmtCreate", type = HttpParamType.COMMON, description = "") Date gmtCreate,
            @HttpParam(name = "gmtUpdate", type = HttpParamType.COMMON, description = "") Date gmtUpdate,
            @HttpParam(name = "userId", type = HttpParamType.COMMON, description = "") Long userId,
            @HttpParam(name = "adminId", type = HttpParamType.COMMON, description = "") Long adminId,
            @HttpParam(name = "pageNum", type = HttpParamType.COMMON, description = "页码", valueDef = "1") Integer page,
            @HttpParam(name = "pageSize", type = HttpParamType.COMMON, description = "页码长度", valueDef = "20") Integer limit)
            throws ServiceException;

    @HttpMethod(description = "删除", permission = "admin:wuye:wuyeAmountInfo:delete", permissionParentName = "宠物管理", permissionName = "info管理")
    public Boolean delete(@NotNull @HttpParam(name = "id", type = HttpParamType.COMMON, description = "") Long id) throws ServiceException;

    @HttpMethod(description = "修改", permission = "admin:wuyeAmountInfo:wuyeAmountInfo:update", permissionParentName = "宠物管理", permissionName = "info管理")
    public Boolean update(@NotNull @HttpParam(name = "wuyeAmountInfo", type = HttpParamType.COMMON, description = "info") WuyeAmountInfo wuyeAmountInfo,
                          @HttpParam(name = "adminId", type = HttpParamType.ADMIN_ID, description = "adminId") Long adminId) throws ServiceException;

    @HttpMethod(description = "查询", permission = "admin:wuye:wuyeAmountInfo:get", permissionParentName = "宠物管理", permissionName = "info管理")
    public WuyeAmountInfo get(@NotNull @HttpParam(name = "id", type = HttpParamType.COMMON, description = "") Long id) throws ServiceException;

    @HttpMethod(description = "查询", permission = "admin:wuye:wuyeAmountInfo:get", permissionParentName = "宠物管理", permissionName = "info管理")
    public WuyeAmountInfo getInfo(@NotNull @HttpParam(name = "wuyeAmountInfo", type = HttpParamType.COMMON, description = "info") WuyeAmountInfo wuyeAmountInfo
    ) throws ServiceException;

    @HttpMethod(description = "导出excl表", permission = "admin:wuye:wuyeAmountInfo:export", permissionParentName = "宠物管理", permissionName = "info管理")
    public String export(
            @HttpParam(name = "buildingNo", type = HttpParamType.COMMON, description = "楼号") String buildingNo,
            @HttpParam(name = "unitNo", type = HttpParamType.COMMON, description = "单元号") String unitNo,
            @HttpParam(name = "floor", type = HttpParamType.COMMON, description = "楼层") String floor,
            @HttpParam(name = "sourceNumber", type = HttpParamType.COMMON, description = "房源号") String sourceNumber,
            @HttpParam(name = "householder", type = HttpParamType.COMMON, description = "户主") String householder,
            @HttpParam(name = "predictedArea", type = HttpParamType.COMMON, description = "预测面积") Double predictedArea,
            @HttpParam(name = "actualMoney", type = HttpParamType.COMMON, description = "实际面积") Double actualMoney,
            @HttpParam(name = "propertyFee", type = HttpParamType.COMMON, description = "一年物业费（1.6元/平）") Double propertyFee,
            @HttpParam(name = "elevatorFee", type = HttpParamType.COMMON, description = "一年电梯费（一层30元/月，每增加一层累加3元/月）") Double elevatorFee,
            @HttpParam(name = "parkingSpace", type = HttpParamType.COMMON, description = "一年车位管理费（单独150元/月,子母225元/月）") Double parkingSpace,
            @HttpParam(name = "cheweiNo", type = HttpParamType.COMMON, description = "车位号") String cheweiNo,
            @HttpParam(name = "garage", type = HttpParamType.COMMON, description = "一年车库管理费（单独150元/月,子母225元/月）") Double garage,
            @HttpParam(name = "garageNo", type = HttpParamType.COMMON, description = "车库号") String garageNo,
            @HttpParam(name = "warehouse", type = HttpParamType.COMMON, description = "一年仓库管理费（200元/年）") Double warehouse,
            @HttpParam(name = "warehouseNo", type = HttpParamType.COMMON, description = "仓库号") String warehouseNo,
            @HttpParam(name = "garbageClearing", type = HttpParamType.COMMON, description = "垃圾清运费（平层建筑面积3元/平，带地下及阁楼5元/平）") Double garbageClearing,
            @HttpParam(name = "paymentDate", type = HttpParamType.COMMON, description = "缴费日期") Date paymentDate,
            @HttpParam(name = "paymentMethod", type = HttpParamType.COMMON, description = "缴费方式") String paymentMethod,
            @HttpParam(name = "totalActualPayment", type = HttpParamType.COMMON, description = "实际缴费总合计") Double totalActualPayment,
            @HttpParam(name = "paymentRange", type = HttpParamType.COMMON, description = "缴费区间") String paymentRange,
            @HttpParam(name = "deleteFlag", type = HttpParamType.COMMON, description = "删除标识") Long deleteFlag,
            @HttpParam(name = "gmtCreate", type = HttpParamType.COMMON, description = "") Date gmtCreate,
            @HttpParam(name = "gmtUpdate", type = HttpParamType.COMMON, description = "") Date gmtUpdate,
            @HttpParam(name = "userId", type = HttpParamType.COMMON, description = "") Long userId,
            @HttpParam(name = "adminId", type = HttpParamType.COMMON, description = "") Long adminId,
            @HttpParam(name = "page", type = HttpParamType.COMMON, description = "页码", valueDef = "1") Integer page,
            @HttpParam(name = "limit", type = HttpParamType.COMMON, description = "页码长度", valueDef = "20") Integer limit) throws ServiceException;

}
