import request from '@/utils/request'

// 查询info列表
export function listInfo(query) {
  return request({
    method: 'get',
    params: {
      _gp: 'admin.wuye.wuyeAmountInfo',
      _mt: 'list',
      ...query
    }
  })
}

// 查询info详细
export function getInfo(id) {
  return request({
    method: 'get',
    params: {
      _gp: 'admin.wuye.wuyeAmountInfo',
      _mt: 'get',
      id: id
    }
  })
}

// 新增info
export function addInfo(data) {
  return request({
    method: 'post',
    params: {
      _gp: 'admin.wuye.wuyeAmountInfo',
      _mt: 'add',
      wuyeAmountInfo: data
    }
  })
}

// 修改info
export function updateInfo(data) {
  return request({
    method: 'post',
    params: {
      _gp: 'admin.wuye.wuyeAmountInfo',
      _mt: 'update',
      wuyeAmountInfo: data
    }
  })
}

// 删除info
export function delInfo(id) {
  return request({
    method: 'post',
    params: {
      _gp: 'admin.wuye.wuyeAmountInfo',
      _mt: 'delete',
      id: id
    }
  })
}

// 导出info
export function exportInfo(query) {
  return request({
    method: 'get',
    params: {
      _gp: 'admin.wuye.wuyeAmountInfo',
      _mt: 'export',
      ...query
    }
  })
}
