package com.iotechn.unimall.app.api.wuye;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.mapper.Wrapper;
import com.iotechn.unimall.core.exception.ServiceException;
import com.iotechn.unimall.data.domain.wuye.WuyeAmountInfo;
import com.iotechn.unimall.data.mapper.wuye.WuyeAmountInfoMapper;
import com.iotechn.unimall.data.model.Page;
import com.iotechn.unimall.data.util.ExcelUtil;
import org.apache.ibatis.session.RowBounds;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.StringUtils;

import java.util.Date;
import java.util.List;

/**
 * infoService业务层处理
 *
 * @author jlb
 * @date 2022-10-12
 */
@Service
public class WuyeAmountInfoServiceAppImpl implements IWuyeAmountInfoAppService {
    @Autowired
    private WuyeAmountInfoMapper wuyeAmountInfoMapper;

    @Override
    public Boolean add(WuyeAmountInfo wuyeAmountInfo, Long adminId) throws ServiceException {
        Date now = new Date();
        wuyeAmountInfo.setGmtCreate(now);
        wuyeAmountInfo.setGmtUpdate(now);
        wuyeAmountInfo.setAdminId(adminId);
        return wuyeAmountInfoMapper.insert(wuyeAmountInfo) > 0;
    }

    @Override
    public Page<WuyeAmountInfo> list(String buildingNo, String unitNo, String floor, String sourceNumber, String householder, Double predictedArea, Double actualMoney, Double propertyFee, Double elevatorFee, Double parkingSpace, String cheweiNo, Double garage, String garageNo, Double warehouse, String warehouseNo, Double garbageClearing, Date paymentDate, String paymentMethod, Double totalActualPayment, String paymentRange, Long deleteFlag, Date gmtCreate, Date gmtUpdate, Long userId, Long adminId, Integer page, Integer limit) throws ServiceException {
        Wrapper<WuyeAmountInfo> wrapper = new EntityWrapper<WuyeAmountInfo>();
        if (!StringUtils.isEmpty(buildingNo)) {
            wrapper.eq("building_no", buildingNo);
        }
        if (!StringUtils.isEmpty(unitNo)) {
            wrapper.eq("unit_no", unitNo);
        }
        if (!StringUtils.isEmpty(floor)) {
            wrapper.eq("floor", floor);
        }
        if (!StringUtils.isEmpty(sourceNumber)) {
            wrapper.eq("source_number", sourceNumber);
        }
        if (!StringUtils.isEmpty(householder)) {
            wrapper.eq("householder", householder);
        }
        if (!StringUtils.isEmpty(predictedArea)) {
            wrapper.eq("predicted_area", predictedArea);
        }
        if (!StringUtils.isEmpty(actualMoney)) {
            wrapper.eq("actual_money", actualMoney);
        }
        if (!StringUtils.isEmpty(propertyFee)) {
            wrapper.eq("property_fee", propertyFee);
        }
        if (!StringUtils.isEmpty(elevatorFee)) {
            wrapper.eq("elevator_fee", elevatorFee);
        }
        if (!StringUtils.isEmpty(parkingSpace)) {
            wrapper.eq("parking_space", parkingSpace);
        }
        if (!StringUtils.isEmpty(cheweiNo)) {
            wrapper.eq("chewei_no", cheweiNo);
        }
        if (!StringUtils.isEmpty(garage)) {
            wrapper.eq("garage", garage);
        }
        if (!StringUtils.isEmpty(garageNo)) {
            wrapper.eq("garage_no", garageNo);
        }
        if (!StringUtils.isEmpty(warehouse)) {
            wrapper.eq("warehouse", warehouse);
        }
        if (!StringUtils.isEmpty(warehouseNo)) {
            wrapper.eq("warehouse_no", warehouseNo);
        }
        if (!StringUtils.isEmpty(garbageClearing)) {
            wrapper.eq("garbage_clearing", garbageClearing);
        }
        if (!StringUtils.isEmpty(paymentDate)) {
            wrapper.eq("payment_date", paymentDate);
        }
        if (!StringUtils.isEmpty(paymentMethod)) {
            wrapper.eq("payment_method", paymentMethod);
        }
        if (!StringUtils.isEmpty(totalActualPayment)) {
            wrapper.eq("total_actual_payment", totalActualPayment);
        }
        if (!StringUtils.isEmpty(paymentRange)) {
            wrapper.eq("payment_range", paymentRange);
        }
        if (!StringUtils.isEmpty(deleteFlag)) {
            wrapper.eq("delete_flag", deleteFlag);
        }
        if (!StringUtils.isEmpty(gmtCreate)) {
            wrapper.eq("gmt_create", gmtCreate);
        }
        if (!StringUtils.isEmpty(gmtUpdate)) {
            wrapper.eq("gmt_update", gmtUpdate);
        }
        if (!StringUtils.isEmpty(userId)) {
            wrapper.eq("user_id", userId);
        }
        if (!StringUtils.isEmpty(adminId)) {
            wrapper.eq("admin_id", adminId);
        }
        wrapper.eq("delete_flag", 0);
        List<WuyeAmountInfo> list = wuyeAmountInfoMapper.selectPage(new RowBounds((page - 1) * limit, limit), wrapper);
        Integer count = wuyeAmountInfoMapper.selectCount(wrapper);
        return new Page<WuyeAmountInfo>(list, page, limit, count);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean delete(Long id) {
        String[] ids = String.valueOf(id).split(",");
        for (String tt : ids) {
            WuyeAmountInfo tmp = wuyeAmountInfoMapper.selectById(Long.parseLong(tt));
            if (tmp != null) {
                tmp.setDeleteFlag(1L);
                wuyeAmountInfoMapper.updateById(tmp);
            }
        }
        return true;
    }

    @Override
    public Boolean update(WuyeAmountInfo wuyeAmountInfo, Long adminId) throws ServiceException {
        Date now = new Date();
        wuyeAmountInfo.setGmtUpdate(now);
        wuyeAmountInfo.setAdminId(adminId);
        return wuyeAmountInfoMapper.updateById(wuyeAmountInfo) > 0;
    }

    @Override
    public WuyeAmountInfo get(Long id) throws ServiceException {
        return wuyeAmountInfoMapper.selectById(id);
    }

	@Override
	public WuyeAmountInfo getInfo(WuyeAmountInfo wuyeAmountInfo) throws ServiceException {
		return wuyeAmountInfoMapper.selectOne(wuyeAmountInfo);
	}

    @Override
    public String export(String buildingNo, String unitNo, String floor, String sourceNumber, String householder, Double predictedArea, Double actualMoney, Double propertyFee, Double elevatorFee, Double parkingSpace, String cheweiNo, Double garage, String garageNo, Double warehouse, String warehouseNo, Double garbageClearing, Date paymentDate, String paymentMethod, Double totalActualPayment, String paymentRange, Long deleteFlag, Date gmtCreate, Date gmtUpdate, Long userId, Long adminId, Integer page, Integer limit) throws ServiceException {
        Wrapper<WuyeAmountInfo> wrapper = new EntityWrapper<WuyeAmountInfo>();
        if (!StringUtils.isEmpty(buildingNo)) {
            wrapper.eq("building_no", buildingNo);
        }
        if (!StringUtils.isEmpty(unitNo)) {
            wrapper.eq("unit_no", unitNo);
        }
        if (!StringUtils.isEmpty(floor)) {
            wrapper.eq("floor", floor);
        }
        if (!StringUtils.isEmpty(sourceNumber)) {
            wrapper.eq("source_number", sourceNumber);
        }
        if (!StringUtils.isEmpty(householder)) {
            wrapper.eq("householder", householder);
        }
        if (!StringUtils.isEmpty(predictedArea)) {
            wrapper.eq("predicted_area", predictedArea);
        }
        if (!StringUtils.isEmpty(actualMoney)) {
            wrapper.eq("actual_money", actualMoney);
        }
        if (!StringUtils.isEmpty(propertyFee)) {
            wrapper.eq("property_fee", propertyFee);
        }
        if (!StringUtils.isEmpty(elevatorFee)) {
            wrapper.eq("elevator_fee", elevatorFee);
        }
        if (!StringUtils.isEmpty(parkingSpace)) {
            wrapper.eq("parking_space", parkingSpace);
        }
        if (!StringUtils.isEmpty(cheweiNo)) {
            wrapper.eq("chewei_no", cheweiNo);
        }
        if (!StringUtils.isEmpty(garage)) {
            wrapper.eq("garage", garage);
        }
        if (!StringUtils.isEmpty(garageNo)) {
            wrapper.eq("garage_no", garageNo);
        }
        if (!StringUtils.isEmpty(warehouse)) {
            wrapper.eq("warehouse", warehouse);
        }
        if (!StringUtils.isEmpty(warehouseNo)) {
            wrapper.eq("warehouse_no", warehouseNo);
        }
        if (!StringUtils.isEmpty(garbageClearing)) {
            wrapper.eq("garbage_clearing", garbageClearing);
        }
        if (!StringUtils.isEmpty(paymentDate)) {
            wrapper.eq("payment_date", paymentDate);
        }
        if (!StringUtils.isEmpty(paymentMethod)) {
            wrapper.eq("payment_method", paymentMethod);
        }
        if (!StringUtils.isEmpty(totalActualPayment)) {
            wrapper.eq("total_actual_payment", totalActualPayment);
        }
        if (!StringUtils.isEmpty(paymentRange)) {
            wrapper.eq("payment_range", paymentRange);
        }
        if (!StringUtils.isEmpty(deleteFlag)) {
            wrapper.eq("delete_flag", deleteFlag);
        }
        if (!StringUtils.isEmpty(gmtCreate)) {
            wrapper.eq("gmt_create", gmtCreate);
        }
        if (!StringUtils.isEmpty(gmtUpdate)) {
            wrapper.eq("gmt_update", gmtUpdate);
        }
        if (!StringUtils.isEmpty(userId)) {
            wrapper.eq("user_id", userId);
        }
        if (!StringUtils.isEmpty(adminId)) {
            wrapper.eq("admin_id", adminId);
        }
        List<WuyeAmountInfo> list = wuyeAmountInfoMapper.selectList(wrapper);
        ExcelUtil<WuyeAmountInfo> util = new ExcelUtil<WuyeAmountInfo>(WuyeAmountInfo.class);
        return util.exportExcel(list, "操作日志");
    }
}
