package com.iotechn.unimall.data.domain.wuye;

import com.iotechn.unimall.data.domain.SuperDO;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.iotechn.unimall.core.framework.aspectj.lang.annotaion.Excel;
import com.iotechn.unimall.core.framework.aspectj.lang.annotaion.Excel.ColumnType;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import lombok.Data;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.enums.FieldFill;
import com.iotechn.unimall.core.util.StringUtils;
import java.util.Date;

/**
 * info对象 wuye_amount_info
 * 
 * @author jlb
 * @date 2022-10-12
 */
@Data
@TableName("wuye_amount_info")
public class WuyeAmountInfo extends SuperDO {
    private static final long serialVersionUID = 1L;

    /**  */
    @TableId("id")
    private Long id;

    /** 楼号 */
    @Excel(name = "楼号")
    @TableField("building_no")
    private String buildingNo;

    /** 单元号 */
    @Excel(name = "单元号")
    @TableField("unit_no")
    private String unitNo;

    /** 楼层 */
    @Excel(name = "楼层")
    @TableField("floor")
    private String floor;

    /** 房源号 */
    @Excel(name = "房源号")
    @TableField("source_number")
    private String sourceNumber;

    /** 户主 */
    @Excel(name = "户主")
    @TableField("householder")
    private String householder;

    /** 预测面积 */
    @Excel(name = "预测面积")
    @TableField("predicted_area")
    private Double predictedArea;

    /** 实际面积 */
    @Excel(name = "实际面积")
    @TableField("actual_money")
    private Double actualMoney;

    /** 一年物业费（1.6元/平） */
    @Excel(name = "一年物业费", readConverterExp = "1=.6元/平")
    @TableField("property_fee")
    private Double propertyFee;

    /** 一年电梯费（一层30元/月，每增加一层累加3元/月） */
    @Excel(name = "一年电梯费", readConverterExp = "一=层30元/月，每增加一层累加3元/月")
    @TableField("elevator_fee")
    private Double elevatorFee;

    /** 一年车位管理费（单独150元/月,子母225元/月） */
    @Excel(name = "一年车位管理费", readConverterExp = "单=独150元/月,子母225元/月")
    @TableField("parking_space")
    private Double parkingSpace;

    /** 车位号 */
    @Excel(name = "车位号")
    @TableField("chewei_no")
    private String cheweiNo;

    /** 一年车库管理费（单独150元/月,子母225元/月） */
    @Excel(name = "一年车库管理费", readConverterExp = "单=独150元/月,子母225元/月")
    @TableField("garage")
    private Double garage;

    /** 车库号 */
    @Excel(name = "车库号")
    @TableField("garage_no")
    private String garageNo;

    /** 一年仓库管理费（200元/年） */
    @Excel(name = "一年仓库管理费", readConverterExp = "2=00元/年")
    @TableField("warehouse")
    private Double warehouse;

    /** 仓库号 */
    @Excel(name = "仓库号")
    @TableField("warehouse_no")
    private String warehouseNo;

    /** 垃圾清运费（平层建筑面积3元/平，带地下及阁楼5元/平） */
    @Excel(name = "垃圾清运费", readConverterExp = "平=层建筑面积3元/平，带地下及阁楼5元/平")
    @TableField("garbage_clearing")
    private Double garbageClearing;

    /** 缴费日期 */
    @Excel(name = "缴费日期", width = 30, dateFormat = "yyyy-MM-dd")
    @TableField("payment_date")
    private Date paymentDate;

    /** 缴费方式 */
    @Excel(name = "缴费方式")
    @TableField("payment_method")
    private String paymentMethod;

    /** 实际缴费总合计 */
    @Excel(name = "实际缴费总合计")
    @TableField("total_actual_payment")
    private Double totalActualPayment;

    /** 缴费区间 */
    @Excel(name = "缴费区间")
    @TableField("payment_range")
    private String paymentRange;

    /** 备注 */
    @Excel(name = "备注")
    @TableField("remark")
    private String remark;

    /** 删除标识 */
    @Excel(name = "删除标识")
    @TableField("delete_flag")
    private Long deleteFlag;

    /**  */
    @Excel(name = "", width = 30, dateFormat = "yyyy-MM-dd")
    @TableField("gmt_create")
    private Date gmtCreate;

    /**  */
    @Excel(name = "", width = 30, dateFormat = "yyyy-MM-dd")
    @TableField("gmt_update")
    private Date gmtUpdate;

    /**  */
    @Excel(name = "")
    @TableField("user_id")
    private Long userId;

    /**  */
    @Excel(name = "")
    @TableField("admin_id")
    private Long adminId;


    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("id", getId())
            .append("buildingNo", getBuildingNo())
            .append("unitNo", getUnitNo())
            .append("floor", getFloor())
            .append("sourceNumber", getSourceNumber())
            .append("householder", getHouseholder())
            .append("predictedArea", getPredictedArea())
            .append("actualMoney", getActualMoney())
            .append("propertyFee", getPropertyFee())
            .append("elevatorFee", getElevatorFee())
            .append("parkingSpace", getParkingSpace())
            .append("cheweiNo", getCheweiNo())
            .append("garage", getGarage())
            .append("garageNo", getGarageNo())
            .append("warehouse", getWarehouse())
            .append("warehouseNo", getWarehouseNo())
            .append("garbageClearing", getGarbageClearing())
            .append("paymentDate", getPaymentDate())
            .append("paymentMethod", getPaymentMethod())
            .append("totalActualPayment", getTotalActualPayment())
            .append("paymentRange", getPaymentRange())
            .append("remark", getRemark())
            .append("deleteFlag", getDeleteFlag())
            .append("gmtCreate", getGmtCreate())
            .append("gmtUpdate", getGmtUpdate())
            .append("userId", getUserId())
            .append("adminId", getAdminId())
            .toString();
    }
}
